Name: nx
Version: 3.3.0
Release: alt10

Summary: Next Generation Remote Display
Group: Networking/Remote access
License: GPL, MIT/X11 for X11 bits
Url: http://www.nomachine.com

Source: nxagent-%version-10.tar.gz
Source1: nxauth-%version-1.tar.gz
Source3: nxcomp-%version-3.tar.gz
Source4: nxcompext-%version-3.tar.gz
Source5: nxcompsh-%version-1.tar.gz
Source6: nxcompshad-%version-3.tar.gz
Source7: nxesd-%version-1.tar.gz
Source9: nxproxy-%version-2.tar.gz
Source10: nxscripts-%version-1.tar.gz
Source12: nxservice-%version-1.tar.gz
Source13: nxssh-%version-1.tar.gz
Source15: nxwin-%version-2.tar.gz
Source16: nx-X11-%version-5.tar.gz
Source18: docs.tar.bz2
Source19: nxfind-provides.sh
Source50: nxagent.1
Source51: nxagent.keyboard

# alt
Patch: nx-X11-alt-SecurityPolicy-path.patch
Patch2: nxcomp-3.2.0-gcc43.patch
Patch3: nxcompsh-3.2.0-gcc43.patch
Patch4: nxcompshad-3.2.0-gcc43.patch
Patch5: nxcompshad-3.3.0-Xext.patch
Patch6: nx-X11-utf8_copy_clipboard.patch
Patch7: nxesd-3.3.0-esd.patch

# linuxforum.ru
Patch40: nx-X11-dimbor.patch
Patch41: nx-X11-dimbor-nxagent.patch

# gentoo
Patch50: nx-3.3.0-cflags.patch

# list
Patch60: createpixmap_bounds_check.patch
Patch61: nxcompext-mem-leak.patch

# debian
Patch85: 85_nx-X11_debian-ld.patch
Patch90: 90_set_X0-config_path.patch
Patch91: 91_enable_debug.patch
Patch93: 93_export_remote_keyboard_config.patch

Packager: Boris Savelev <boris@altlinux.org>

Obsoletes: NX
Provides: NX = %version

Obsoletes: libXcomp
Provides: libXcomp = %version

Obsoletes: libXcompext
Provides: libXcompext = %version

Obsoletes: libXcompshad
Provides: libXcompshad = %version

%set_verify_elf_method unresolved=relaxed

%define _use_internal_dependency_generator 0
%define __find_provides %SOURCE19

# Automatically added by buildreq on Tue Dec 02 2008
BuildRequires: docbook-utils gcc-c++ groff-base imake libice-devel libXrender-devel
BuildRequires: libXdamage-devel libXrandr-devel libXt-devel libXtst-devel libXext-devel
BuildRequires: libarts-devel libjpeg-devel libpam-devel libesd-devel
BuildRequires: libssl-devel libstdc++-devel makedepend
BuildRequires: xorg-cf-files xorg-inputproto-devel xorg-sdk xorg-xextproto-devel

%description
NX is an exciting new technology for remote display. It provides near local
speed application responsiveness over high latency, low bandwidth links. The
core libraries for NX are provided by NoMachine under the GPL.

%prep
tar xzf %SOURCE0
tar xzf %SOURCE1
tar xzf %SOURCE3
tar xzf %SOURCE4
tar xzf %SOURCE5
tar xzf %SOURCE6
tar xzf %SOURCE7
tar xzf %SOURCE9
tar xzf %SOURCE10
tar xzf %SOURCE12
tar xzf %SOURCE13
tar xzf %SOURCE15
tar xzf %SOURCE16

%patch0 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0

%patch40 -p0
%patch41 -p0

%patch50 -p0

%patch60 -p0
%patch61 -p0

pushd nx-X11
%patch85 -p1
%patch90 -p1
# disable debug?
# %patch91 -p2
%patch93 -p1
popd

cat >> nx-X11/config/cf/host.def << EOF
#ifdef  i386Architecture
#undef  DefaultGcc2i386Opt
#define DefaultGcc2i386Opt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  MipsArchitecture
#undef  DefaultGcc2MipsOpt
#define DefaultGcc2MipsOpt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef s390xArchitecture
#undef OptimizedCDebugFlags
#define OptimizedCDebugFlags $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  AMD64Architecture
#undef  DefaultGcc2AMD64Opt
#define DefaultGcc2AMD64Opt $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
EOF

%build
export CFLAGS="%optflags"
export CXXFLAGS="%optflags"
sed -i "s|CXXFLAGS=.-O.*|CXXFLAGS=\"$CXXFLAGS\"|" */configure
# build Compression Library and Proxy
for i in nxcomp nxproxy nxcompshad; do
pushd $i
%autoreconf
%configure
%ifarch x86_64 s390x ia64 ppc64
sed -i "s,/usr/X11R6/lib ,/usr/X11R6/lib64 ,g" Makefile
%endif
%make_build
popd
done

# build X11 Support Libraries and Agents
pushd nx-X11
%make_build World
popd

# build Extended Compression Library
pushd nxcompext
%autoreconf
%configure
%make_build
popd
# build nxssh
pushd nxssh
%configure --without-zlib-version-check
%make
popd
# build nxesd
pushd nxesd
%configure
# multi proc build is broken on many systems
%make
popd
# build nxcompsh
pushd nxcompsh
%configure
%make_build
popd
# build nxservice
pushd nxservice
%configure
%make_build
popd

%install
mkdir -p %buildroot%_bindir
mkdir -p %buildroot%_libdir
mkdir -p %buildroot%_sysconfdir/nxagent
mkdir -p %buildroot%_man1dir

# install X11 Support Libraries and Agents
cp -a nx-X11/lib/X11/libX11-nx.so.* \
     nx-X11/lib/Xext/libXext-nx.so.* \
     nx-X11/lib/Xrender/libXrender-nx.so.* \
%buildroot%_libdir/

install -m 755 nx-X11/programs/Xserver/nxagent \
%buildroot%_bindir/

# install Compression Libraries and Proxy
cp -a nxcomp/libXcomp.so* %buildroot%_libdir/
cp -a nxcompext/libXcompext.so* %buildroot%_libdir/
cp -a nxcompshad/libXcompshad.so* %buildroot%_libdir/
cp -a nxcompsh/libXcompsh.so* %buildroot%_libdir/
install -m 755 nxproxy/nxproxy %buildroot%_bindir/
# install nxssh
pushd nxssh
install -m755 nxssh %buildroot%_bindir/
popd
# install nxesd
pushd nxesd
install -m755 .libs/nxesd %buildroot%_bindir/
popd

pushd nxservice
install -m755 nxservice %buildroot%_bindir/
popd

# install scripts
if [ ! -d %buildroot%_docdir/%name-%version ]; then
mkdir -p %buildroot%_docdir/%name-%version/
fi
cp -r nxscripts %buildroot%_docdir/%name-%version/
# documentation and license
tar xjf %SOURCE18 -C %buildroot%_docdir/%name-%version/
install -m 644 nxcomp/LICENSE %buildroot%_docdir/%name-%version/
if [ ! -d %buildroot%_docdir/%name-%version/nxcomp ]; then
mkdir %buildroot%_docdir/%name-%version/nxcomp
fi
install -m 644 nxcomp/README %buildroot%_docdir/%name-%version/nxcomp

install %SOURCE50 %buildroot%_man1dir/
gzip -3 %buildroot%_man1dir/*
install %SOURCE51 %buildroot%_sysconfdir/nxagent/

# for backcompat
ln -s ../bin/nxagent %buildroot%_libdir

%post
%post_ldconfig

%postun
%postun_ldconfig

%files
%doc %_docdir/%name-%version
%dir %_sysconfdir/nxagent
%config %_sysconfdir/nxagent/nxagent.keyboard
%_bindir/nxagent
%_bindir/nxesd
%_bindir/nxproxy
%_bindir/nxssh
%_bindir/nxservice
%_libdir/lib*.so*
%_libdir/nxagent
%_man1dir/*

%changelog
* Sat Mar 14 2009 Boris Savelev <boris@altlinux.org> 3.3.0-alt10
- fix memory leak in nxcompext with png compress

* Mon Mar 09 2009 Boris Savelev <boris@altlinux.org> 3.3.0-alt9
- move all libs to %%_libdir
- move all binaries to %%_bindir
- add nxagent man
- add fix for non-ascii character in window titles for Windows client
- add nxagent keyboard settings patch (new directory %_sysconfdir/nxagent)

* Fri Jan 23 2009 Boris Savelev <boris@altlinux.org> 3.3.0-alt8
- fix build nxesd (bug #18620)

* Fri Jan 23 2009 Boris Savelev <boris@altlinux.org> 3.3.0-alt7
- new verison:
    nxagent
    nx-X11
    nxcompshad

* Wed Jan 19 2009 Boris Savelev <boris@altlinux.org> 3.3.0-alt6
- back devel *.so (for proprietary soft)
- new verison:
    nxagent
    nx-X11
    nxcompext
- fix buildreq

* Tue Dec 30 2008 Boris Savelev <boris@altlinux.org> 3.3.0-alt5
- add Clipboard patch from dimbor
- remove devel *.so

* Fri Dec 05 2008 Yuri Fil <yurifil@altlinux.org> 3.3.0-alt4
- fix linking in nxesd

* Fri Dec 05 2008 Yuri Fil <yurifil@altlinux.org> 3.3.0-alt3
- don't build nxesd docs (due problem with jade)

* Fri Dec 05 2008 Yuri Fil <yurifil@altlinux.org> 3.3.0-alt2
- fix build on Mandriva/2009.0

* Sat Nov 22 2008 Boris Savelev <boris@altlinux.org> 3.3.0-alt1
- 3.3.0 release

* Tue Jul 15 2008 Boris Savelev <boris@altlinux.org> 3.2.0-alt3
- Fixed TR07F02082. The agent server could be unable to init core
  keyboard on 64 bit systems.

* Thu Jul 03 2008 Boris Savelev <boris@altlinux.org> 3.2.0-alt2
- Imported patch fixing issues from  X.Org security advisory, June
  11th, 2008: Multiple vulnerabilities in X server extensions. CVE
  IDs: CVE-2008-1377, CVE-2008-1379, CVE-2008-2360, CVE-2008-2361,
  CVE-2008-2362.
- new nx-X11 and nxagent

* Sat Jun 14 2008 Boris Savelev <boris@altlinux.org> 3.2.0-alt1
- new version

